import { useState, useEffect } from "react";
import { newGuid } from "primeobjects-helper-util/build/cjs/uuid";
import { SSR } from "primeobjects-helper-util/build/cjs/constants";
import { getWindow } from "primeobjects-helper-util/build/cjs/core";
import { doNothing, getCache, setCache, } from "primeobjects-helper-util/build/cjs/core";
var SOURCE = "PO-USE-EVENT";
export var sendEvent = function (channel, value, expireMinutes, senderName) {
    if (SSR)
        return console.error("Require window object.");
    var data = { value: value, senderName: senderName, id: newGuid() };
    setCache(channel, data, expireMinutes);
    getWindow().postMessage({ source: SOURCE, channel: channel });
};
export var useEvent = function (channel) {
    var data = getCache(channel, { data: "", id: "" });
    var _a = useState(""), valueRefreshed = _a[0], setValuedRefreshed = _a[1];
    var isSSR = SSR;
    doNothing(valueRefreshed);
    var messageHandler = function (message) {
        var data = message.data;
        if (data.source == SOURCE && data.channel == channel) {
            setValuedRefreshed(newGuid());
        }
    };
    useEffect(function () {
        var win = getWindow();
        if (isSSR) {
            console.error("Require window object.");
        }
        else {
            if (win.addEventListener) {
                win.addEventListener("message", messageHandler);
            }
            else {
                win.attachEvent("onmessage", messageHandler);
            }
        }
        return function () {
            if (win.removeEventListener)
                win.removeEventListener("message", messageHandler);
            if (win.detachEvent)
                win.detachEvent("onmessage", messageHandler);
        };
    }, [isSSR]);
    return [data];
};
